<?php

namespace Drupal\content_synchronizer\Processors\Type;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\TypedData\TypedData;

/**
 * Default type processor.
 *
 * @package Drupal\content_synchronizer\Processors\Type
 */
class DefaultTypeProcessor implements TypeProcessorInterface {

  /**
   * {@inheritdoc}
   */
  public function getPluginId() {
    return 'type_processor_default';
  }

  /**
   * {@inheritdoc}
   */
  public function getPluginDefinition() {
    return [];
  }

  /**
   * {@inheritdoc}
   */
  public function getExportedData(TypedData $propertyData) {
    $data = [];
    foreach ($propertyData as $value) {
      $data[] = $value->getValue();
    }
    return $data;
  }

  /**
   * {@inheritdoc}
   */
  public function initImportedEntity(EntityInterface $entity_to_import, $property_id, array $data) {
    $entity_to_import->set($property_id, $data[$property_id]);
  }

}
